#include "io.h"
#include "queue.h"

int yylineno;
char yytext[20];

void test_dlist()
{
  int i;

  dlist l =
    consAtEnd( "biere",
    consAtEnd( "ist",
    consAtEnd( "in",
    consAtEnd( "der",
    consAtEnd( "Schlange", 0)))));

  for(i=0; i<3; i++)
    {
      prS((char*)carAtFront(l)); prC(' ');
      l = cdrAtFront(l);
    }

  l = consAtEnd( "armin", l );

  for(;l;)
    {
      prS((char*)carAtFront(l)); prC(' ');
      l = cdrAtFront(l);
    }

  prC('\n');
}

char* data[] = {
 "Here", "we", "go", "and", "test", "this", "version", "of", "dlist.",
 "It", "seems", "to", "be", "very", "stable.",
 "We", "use", "a", "random", "insertion", "operation", "with", "a", "probability", "of", "2/3.",
 0 /* sentinel */
};

  
void test_dlist2()
{
  dlist l = 0;
  char ** next = data;

  while(l||*next)
    {
      if(!l)
        {
	  l = consAtEnd(*next++, l);
	}
      else
        {
	  if(*next && rand()%3)
	    {
	      l = consAtEnd(*next++, l);
	    }
	  if(l && rand()%2)
	    {
	      prS((char*)carAtFront(l));
	      prC(' ');
	      l = cdrAtFront(l);
	    }
	}
    }
}

main(int argc, char** argv) { if(argc)test_dlist2();else test_dlist(); exit(0); }
