#include <ctype.h>
#include <string.h>

#include "io.h"
#include "labels.h"
#include "mem.h"

CellCodeTemplate(label)

label newLabel(char *s)
{
  label new = label_newCell();
  new->text = strcpy( (char*)save_malloc(strlen(s)+1),  s);
  return new;
}

void disposeLabel(label l)
{
  free(l->text);
  free(l);
}

void printLabel(label l)
{
  char *p;
  if(!l || !l->text) return;
  for(p=l->text; *p && isalnum(*p); p++)
    ;
  if(*p)
    fprintf(io_output, "\"%s\"", l->text);
  else
    fprintf(io_output, "'%s", l->text);
}
