#ifndef _queue_h
#define _queue_h

typedef struct _dlist {
  void* data;
  struct _dlist* prev;
  struct _dlist* next;
} _dlist, *dlist;

extern dlist consAtEnd(void*,dlist);
extern dlist cdrAtFront(dlist);
extern void* carAtFront(dlist);

typedef dlist queue;
extern queue insertInSortedQueue(void*,queue,int(*)(void*,void*));

#define insertInQueue(d,q) consAtEnd(d,q)
#define firstInQueue(q) carAtFront(q)
#define removeFromQueue(q) cdrAtFront(q)

#endif
